-- functions.lua
-- Written By Habna


-- **v Hide HugeBag v**
function ShowHugeBag()
	if ( frmMain:IsVisible() ) then
		write( "HugeBag: Impossible, I'm already visible" );
	else
		frmMain:SetVisible( true );
		--write( "HugeBag: I'm now visible" );
	end
end
-- **^
-- **v Hide HugeBag v**
function HideHugeBag()
	if ( not frmMain:IsVisible() ) then
		write( "HugeBag: Impossible, I'm already hidden" );
	else
		frmMain:SetVisible( false );
		--write( "HugeBag: I'm now hidden" );
	end
end
-- **^
-- **v Show Settings window v**
function ShowCurrentSettings()
	import "HabnaPlugins.HugeBag.contextMenu"; -- LUA contextual menu file
	contextMenu();
end
-- **^
-- **v Toggle Slots Info v**
function ToggleSlotsInfo()
	ShowSlotsInfo = ( not ShowSlotsInfo );
	SaveSettings();
	frmMain:PrintTitle();
	--[[
	if ( ShowSlotsInfo ) then
		write( "HugeBag: Now showing slots informations in the title" );
	else
		write( "HugeBag: Not showing slots informations in the title" );
	end
	]]
end
-- **^
-- **v Toggle Items Orientation v**
function ToggleItemsOrientation()
	HorizontalOrientation = ( not HorizontalOrientation );
	frmMain:PerformLayout();
	SaveSettings();
end
-- **^
-- **v Toggle 'Sort/Merge/Search' button on & off v**
function ToggleButton()
	ShowButton = ( not ShowButton );
	SaveSettings();
	if ShowButton then
		write( "HugeBag: All buttons are visible now" );
		SortButton:SetVisible( true );
		SearchButton:SetVisible( true );
		MergeButton:SetVisible( true );
	else
		write( "HugeBag: All buttons are NOT visible now" );
		SortButton:SetVisible( false );
		SearchButton:SetVisible( false );
		MergeButton:SetVisible( false );
	end
end
-- **^
--[[ Disabled until i found a way to reverse the scrollbar in the same orientation (Top goes to bottom, bottom goes to top)
-- **v Toggle Items ReverseFill v**
function ToggleItemsReverseFill()
	ReverseFill = ( not ReverseFill );
	frmMain.itemListBox:SetReverseFill( ReverseFill );
	frmMain:PerformLayout();
	SaveSettings();
end
-- **^
]]
-- **v Lock HugeBag Position v**
function LockHugeBagSize()
	LockSize = ( not LockSize );
	SaveSettings();
	--[[
	if ( LockSize ) then
		write( "HugeBag: My size is now lock." );
	else
		write( "HugeBag: My size is now unlock." );
	end
	]]
end
-- **^
-- **v Lock HugeBag Position v**
function LockHugeBagPosition()
	LockPosition = ( not LockPosition );
	LockLabel.Enable = not LockPosition;
	SaveSettings();
	--[[
	if ( LockPosition ) then
		--write( "HugeBag: My position is now lock." );
	else
		--write( "HugeBag: My position is now unlock." );
	end
	]]
end
-- **^
-- **v Options List v**
function LoadListOptionsName()
	OptionNameList = {};
	OptionNameList[1]= "Show 'free/used/max' info in title: ";
	OptionNameList[2]= "Start visible at startup: ";
	OptionNameList[3]= "Hide HugeBag when 'esc' key is press: ";
	OptionNameList[4]= "Size locker activated: ";
	OptionNameList[5]= "Position locker activated: ";
	OptionNameList[6]= "HugeBag mode: ";
	OptionNameList[7]= "Show HugeBag title: ";
	OptionNameList[8]= "Show HugeBag skin: ";
	OptionNameList[9]= "Orientation of items: ";
	--OptionNameList[10]= "Reverse fill the items: ";
	OptionNameList[10]= "HugeBag always on top: ";
	OptionNameList[11]= "Show 'Sort/Merge/Search' buttons: ";
end
-- **^
-- **v Shell command List v**
function LoadShellCommandName()
	ShellCommandName = {};
	ShellCommandName[1]= "show";
	ShellCommandName[2]= "hide";
	ShellCommandName[3]= "unload";
	ShellCommandName[4]= "reload";
	ShellCommandName[5]= "resetls";
	ShellCommandName[6]= "resetall";
	ShellCommandName[7]= "wesc";
	ShellCommandName[8]= "visible";
	ShellCommandName[9]= "mode";
	ShellCommandName[10]= "slots";
	ShellCommandName[11]= "title";
	ShellCommandName[12]= "skin";
	ShellCommandName[13]= "aot";
	ShellCommandName[14]= "buttons";
	ShellCommandName[15]= "orientation";
	--ShellCommandName[16]= "reversefill";
	ShellCommandName[16]= "options";
	ShellCommandName[17]= "locksize";
	ShellCommandName[18]= "lockpos";
	ShellCommandName[19]= "sort"
	ShellCommandName[20]= "merge"
	ShellCommandName[21]= "about";
	ShellCommandName[22]= "help/?";
end
-- **^
-- **v Shell Command description list v**
function LoadShellCommandDes()
	ShellCommandDes = {};
	ShellCommandDes[1]= "Show HugeBag";
	ShellCommandDes[2]= "Hide HugeBag";
	ShellCommandDes[3]= "Unload HugeBag (NOT WORKING, Turbine API Issues)";
	ShellCommandDes[4]= "Reload HugeBag (NOT WORKING, Turbine API Issues)";
	ShellCommandDes[5]= "Reset location and size settings to default";
	ShellCommandDes[6]= "Reset all settings to default";
	ShellCommandDes[7]= "Toggle hide HugeBag event when the 'esc' key is press";
	ShellCommandDes[8]= "Show or hide HugeBag at startup";
	ShellCommandDes[9]= "Toggle between widget and window mode";
	ShellCommandDes[10]= "Show or hide slots information in title";
	ShellCommandDes[11]= "Toggle HugeBag title on & off";
	ShellCommandDes[12]= "Toggle HugeBag skin on and off";
	ShellCommandDes[13]= "Toggle HugeBag ability to be always on top are not";
	ShellCommandDes[14]= "Toggle all buttons visibility";
	ShellCommandDes[15]= "Toggle items oriention";
	--ShellCommandDes[16]= "Toggle reverse fill of items (NOT WORKING)";
	ShellCommandDes[16]= "Show HugeBag Options";
	ShellCommandDes[17]= "Lock/unlock HugeBag size";
	ShellCommandDes[18]= "Lock/unlock HugeBag position";
	ShellCommandDes[19]= "Sort HugeBag items (Courtesy of MrJackdaw)"
	ShellCommandDes[20]= "Merge stackable items into one stack"
	ShellCommandDes[21]= "Show the 'About' window";
	ShellCommandDes[22]= "Show HugeBag shell commands/?";
end