-- optionsWidget.lua
-- Written By Habna


-- **v Set context menu items v**
local LocMenu = Turbine.UI.MenuItem( "Set HugeBag widget location to..." );
local LocMenuItems = LocMenu:GetItems();
LocItems = {};

LocItems[1] = Turbine.UI.MenuItem( "right" );
LocItems[1].Click = function( sender, args )
	WidLoc("right");
	menu:ShowMenuAt(frmMain:GetLeft() - 338, frmMain:GetTop());
end

LocItems[2] = Turbine.UI.MenuItem( "left" );
LocItems[2].Click = function( sender, args )
	WidLoc("left");
	menu:ShowMenuAt(frmMain:GetWidth() + 5, frmMain:GetTop());
end

for i = 1, 2 do	LocMenuItems:Add( LocItems[i] ); end


local topOptMenu = Turbine.UI.MenuItem( "top bar options ..." );
local topOptMenuItems = topOptMenu:GetItems();
topOptItems = {};

topOptItems[1] = Turbine.UI.MenuItem( "Show HugeBag title" );
topOptItems[1].Click = function( sender, args )
	ToggleTopBarInfo("title");
	if WidgetLoc == "left" then
		menu:ShowMenuAt(frmMain:GetLeft() + frmMain:GetWidth() + 5, frmMain:GetTop());
	else
		menu:ShowMenuAt(frmMain:GetLeft() - 338, frmMain:GetTop());
	end
end

topOptItems[2] = Turbine.UI.MenuItem( "Show slots informations" );
topOptItems[2].Click = function( sender, args )
	ToggleTopBarInfo("info");
	if WidgetLoc == "left" then
		menu:ShowMenuAt(frmMain:GetLeft() + frmMain:GetWidth() + 5, frmMain:GetTop());
	else
		menu:ShowMenuAt(frmMain:GetLeft() - 338, frmMain:GetTop());
	end
end

topOptItems[3] = Turbine.UI.MenuItem( "Show nothing" );
topOptItems[3].Click = function( sender, args )
	ToggleTopBarInfo("nil");
	if WidgetLoc == "left" then
		menu:ShowMenuAt(frmMain:GetLeft() + frmMain:GetWidth() + 5, frmMain:GetTop());
	else
		menu:ShowMenuAt(frmMain:GetLeft() - 338, frmMain:GetTop());
	end
end

for i = 1, #topOptItems do	topOptMenuItems:Add( topOptItems[i] ); end

local sideOptMenu = Turbine.UI.MenuItem( "Side bar options ..." );
local sideOptMenuItems = sideOptMenu:GetItems();
sideOptItems = {};

sideOptItems[1] = Turbine.UI.MenuItem( "Show HugeBag Image" );
sideOptItems[1].Click = function( sender, args )
	ToggleSideBarInfo("image");
	if WidgetLoc == "left" then
		menu:ShowMenuAt(frmMain:GetLeft() + frmMain:GetWidth() + 5, frmMain:GetTop());
	else
		menu:ShowMenuAt(frmMain:GetLeft() - 338, frmMain:GetTop());
	end
end

sideOptItems[2] = Turbine.UI.MenuItem( "Show slots informations" );
sideOptItems[2].Click = function( sender, args )
	ToggleSideBarInfo("info");
	if WidgetLoc == "left" then
		menu:ShowMenuAt(frmMain:GetLeft() + frmMain:GetWidth() + 5, frmMain:GetTop());
	else
		menu:ShowMenuAt(frmMain:GetLeft() - 338, frmMain:GetTop());
	end
end

sideOptItems[3] = Turbine.UI.MenuItem( "Show nothing" );
sideOptItems[3].Click = function( sender, args )
	ToggleSideBarInfo("nil");
	if WidgetLoc == "left" then
		menu:ShowMenuAt(frmMain:GetLeft() + frmMain:GetWidth() + 5, frmMain:GetTop());
	else
		menu:ShowMenuAt(frmMain:GetLeft() - 338, frmMain:GetTop());
	end
end

for i = 1, #sideOptItems do	sideOptMenuItems:Add( sideOptItems[i] ); end

local botOptMenu = Turbine.UI.MenuItem( "Bottom bar options ..." );
local botOptMenuItems = botOptMenu:GetItems();
botOptItems = {};

botOptItems[1] = Turbine.UI.MenuItem( "Toggle all buttons visibility" );
botOptItems[1].Click = function( sender, args )
	ToggleBotBarInfo("butvis");
	if WidgetLoc == "left" then
		menu:ShowMenuAt(frmMain:GetLeft() + frmMain:GetWidth() + 5, frmMain:GetTop());
	else
		menu:ShowMenuAt(frmMain:GetLeft() - 338, frmMain:GetTop());
	end
end

for i = 1, #botOptItems do	botOptMenuItems:Add( botOptItems[i] ); end


menu = Turbine.UI.ContextMenu();
menu.items = menu:GetItems();

local option_line = Turbine.UI.MenuItem("-----------------------------------------------------------------------", false);

local option_toggleshow = Turbine.UI.MenuItem("Toggle the startup visibility of HugeBag", true, "visible");
option_toggleshow.Click = function( sender, args )
	ToggleShow();
	if WidgetLoc == "left" then
		menu:ShowMenuAt(frmMain:GetLeft() + frmMain:GetWidth() + 5, frmMain:GetTop());
	else
		menu:ShowMenuAt(frmMain:GetLeft() - 338, frmMain:GetTop());
	end
end

local option_togglewesc = Turbine.UI.MenuItem("Toggle hide event when the 'esc' key is press", true, "wesc");
option_togglewesc.Click = function( sender, args )
	ToggleWEsc();
	if WidgetLoc == "left" then
		menu:ShowMenuAt(frmMain:GetLeft() + frmMain:GetWidth() + 5, frmMain:GetTop());
	else
		menu:ShowMenuAt(frmMain:GetLeft() - 338, frmMain:GetTop());
	end
end

local option_togglewidget = Turbine.UI.MenuItem("Toggle from 'widget' and 'window' mode", true, "mode");
option_togglewidget.Click = function( sender, args )
	ToggleMode();
	if WidgetLoc == "left" then
		menu:ShowMenuAt(frmMain:GetLeft() + frmMain:GetWidth() + 5, frmMain:GetTop());
	else
		menu:ShowMenuAt(frmMain:GetLeft() - 338, frmMain:GetTop());
	end
end

local option_toggleaot = Turbine.UI.MenuItem("Toggle HugeBag 'Always On Top' ability", true, "aot");
option_toggleaot.Click = function( sender, args )
	ToggleAlwaysOnTop();
	if WidgetLoc == "left" then
		menu:ShowMenuAt(frmMain:GetLeft() + frmMain:GetWidth() + 5, frmMain:GetTop());
	else
		menu:ShowMenuAt(frmMain:GetLeft() - 338, frmMain:GetTop());
	end
end

local option_help = Turbine.UI.MenuItem("Show HugeBag widget shell commands", true, "help");
option_help.Click = HelpInfo;

local option_resetall = Turbine.UI.MenuItem("Reset all settings to default", true, "resetall");
option_resetall.Click = ResetSettings;

local option_backcolor = Turbine.UI.MenuItem("Set HugeBag widget background color", true, "backcolor");
option_backcolor.Click = SetBackgroundColor;
--[[
local option_reload = Turbine.UI.MenuItem("Reload HugeBag plugin instance", true, "reload");
option_reload.Click = ReloadHugeBag;

local option_unload = Turbine.UI.MenuItem("Unload HugeBag plugin from memory", true, "unload");
option_unload.Click = UnloadHugeBag;
]]
local option_about = Turbine.UI.MenuItem("About HugeBag", true, "about");
option_about.Click = ShowAbout;

menu.items:Add(option_togglewidget);
menu.items:Add(option_toggleshow);
menu.items:Add(option_togglewesc);
menu.items:Add(option_toggleaot);
menu.items:Add(option_line); ------
menu.items:Add(topOptMenu);
menu.items:Add(sideOptMenu);
menu.items:Add(botOptMenu);
menu.items:Add(option_line);
menu.items:Add(option_backcolor);
menu.items:Add(LocMenu);
menu.items:Add(option_line); ------
--menu.items:Add(option_reload);
--menu.items:Add(option_unload);
menu.items:Add(option_help);
menu.items:Add(option_resetall);
menu.items:Add(option_about);
-- **^